libdap::Response Class Reference

`#include <Response.h>`

Inheritance diagram for libdap::Response:

## Public Member Functions

| Response (FILE *s, int status=0)
| Response (std::fstream *s, int status=0)
virtual | ~Response ()
getters
virtual int | get_status () const
virtual FILE * | get_stream () const
virtual std::istream * | get_cpp_stream () const
virtual ObjectType | get_type () const
virtual std::string | get_version () const
virtual std::string | get_protocol () const
setters
virtual void | set_status (int s)
virtual void | set_stream (FILE *s)
virtual void | set_cpp_stream (std::istream *s)
virtual void | set_type (ObjectType o)
virtual void | set_version (const std::string &v)
virtual void | set_protocol (const std::string &p)

## Protected Member Functions

Suppressed default methods
| Response (const Response &)
Response & | operator= (const Response &)

## Detailed Description

Encapsulate a response. Instead of directly returning the FILE pointer from which a response is read, return an instance of this object. For a simple system where all that needs to be done to free the stream and its associated resources, this is overkill. However, some streams may require complex operations to free their resources once the client is done with the stream. Those classes should return a subclass of Response which has those operations built into the destructor.

Todo:
  If the code that parses the MIME headers was moved from Connect and HTTPConnect to this class and its children, it would be easier to build a FileConnect class (or maybe the specifics of the connection type could be held in the Response object and HTTPConnect and the to-be-written FileConnect would not be needed).

Definition at line 53 of file Response.h.

## Constructor & Destructor Documentation

## Response()

libdap::Response::Response | ( | FILE * | s,
|  | int | status = `0`
| ) |  |

inline

Initialize with a stream. Create an instance initialized to a stream. by default get_type() and get_version() return default values of unknown_type and "dods/0.0", respectively. Specializations (see HTTPResponse and HTTPConnect) may fill these fields in with other values.

Parameters

  s | Read data from this stream.
  status | The HTTP response status code.

Definition at line 88 of file Response.h.

## ~Response()

virtual libdap::Response::~Response | ( |  | ) |

inline virtual

Close the stream.

Definition at line 95 of file Response.h.

The documentation for this class was generated from the following file:

- Response.h